package com.r11.tools.controller;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.r11.tools.controller.internal.GlobalControllerManifest;
import com.r11.tools.controller.internal.HandlerType;
import com.r11.tools.controller.internal.RestController;
import com.r11.tools.controller.internal.ScopedControllerManifest;
import com.r11.tools.xml.Saxon;
import com.r11.tools.xml.Xalan;
import org.apache.logging.log4j.Logger;
import spark.Request;
import spark.Response;

@GlobalControllerManifest
public class XsltController implements RestController {

    private final Gson gson;
    private final Logger logger;

    public XsltController(Gson gson, Logger logger) {
        this.gson = gson;
        this.logger = logger;
    }

    @ScopedControllerManifest(method = HandlerType.POST, path = "/xslt")
    public void transform(Request request, Response response) {
        String body = request.body();

        JsonObject requestJson;
        try {
            requestJson = this.gson.fromJson(body, JsonObject.class);
        } catch (Exception e) {
            JsonObject responseJson = new JsonObject();
            responseJson.addProperty("result", e.getMessage());
            responseJson.addProperty("processor", "N/A");
            responseJson.addProperty("status", "ERR");
            responseJson.addProperty("time", "N/A");

            response.status(400);
            response.body(this.gson.toJson(responseJson));
            return;
        }

        String data = requestJson.get("data").getAsString();
        String query = requestJson.get("process").getAsString();
        String processor = requestJson.get("processor").getAsString();
        String version = requestJson.get("version").getAsString();

        if (processor == null) {
            response.body("saxon, xalan");
            return;
        }

        String tmp;
        long timeStart;
        long duration;

        JsonObject responseJson = new JsonObject();
        switch (processor) {
            case "saxon":
                timeStart = System.currentTimeMillis();
                try {
                    tmp = Saxon.processXSLT(data, query);

                    response.status(200);

                    responseJson.addProperty("result", tmp);
                    responseJson.addProperty("status", "OK");
                } catch (Exception ex) {
                    this.logger.error("Error on processing XSLT using Saxon. " + ex);

                    response.status(400);

                    responseJson.addProperty("result", ex.getMessage());
                    responseJson.addProperty("status", "ERR");
                }

                duration = System.currentTimeMillis() - timeStart;
                this.logger.info("Request (XSLT, Saxon) processed in " + duration + " ms.");

                responseJson.addProperty("processor", "Saxon " + Saxon.getVersion() + " " + version);
                responseJson.addProperty("time", duration);

                response.body(this.gson.toJson(responseJson));
                return;

            case "xalan":
                timeStart = System.currentTimeMillis();
                try {
                    tmp = Xalan.processXSLT(data, query);

                    response.status(200);

                    responseJson.addProperty("result", tmp);
                    responseJson.addProperty("status", "OK");
                } catch (Exception ex) {
                    this.logger.error("Error on processing XSLT using Xalan. " + ex);

                    response.status(400);

                    responseJson.addProperty("result", ex.getMessage());
                    responseJson.addProperty("status", "ERR");
                }

                duration = System.currentTimeMillis() - timeStart;
                this.logger.info("Request (XSLT, Xalan) processed in " + duration + " ms.");

                responseJson.addProperty("processor", Xalan.getVersion());
                responseJson.addProperty("time", duration);

                response.body(this.gson.toJson(responseJson));
                return;

            default:
                response.body("saxon, xalan");
        }
    }
}
